package b4a.example;


import anywheresoftware.b4a.B4AMenuItem;
import android.app.Activity;
import android.os.Bundle;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.B4AActivity;
import anywheresoftware.b4a.ObjectWrapper;
import anywheresoftware.b4a.objects.ActivityWrapper;
import java.lang.reflect.InvocationTargetException;
import anywheresoftware.b4a.B4AUncaughtException;
import anywheresoftware.b4a.debug.*;
import java.lang.ref.WeakReference;

public class main extends Activity implements B4AActivity{
	public static main mostCurrent;
	static boolean afterFirstLayout;
	static boolean isFirst = true;
    private static boolean processGlobalsRun = false;
	BALayout layout;
	public static BA processBA;
	BA activityBA;
    ActivityWrapper _activity;
    java.util.ArrayList<B4AMenuItem> menuItems;
	public static final boolean fullScreen = false;
	public static final boolean includeTitle = true;
    public static WeakReference<Activity> previousOne;
    public static boolean dontPause;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
        mostCurrent = this;
		if (processBA == null) {
			processBA = new BA(this.getApplicationContext(), null, null, "b4a.example", "b4a.example.main");
			processBA.loadHtSubs(this.getClass());
	        float deviceScale = getApplicationContext().getResources().getDisplayMetrics().density;
	        BALayout.setDeviceScale(deviceScale);
            
		}
		else if (previousOne != null) {
			Activity p = previousOne.get();
			if (p != null && p != this) {
                BA.LogInfo("Killing previous instance (main).");
				p.finish();
			}
		}
        processBA.setActivityPaused(true);
        processBA.runHook("oncreate", this, null);
		if (!includeTitle) {
        	this.getWindow().requestFeature(android.view.Window.FEATURE_NO_TITLE);
        }
        if (fullScreen) {
        	getWindow().setFlags(android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN,   
        			android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN);
        }
		
        processBA.sharedProcessBA.activityBA = null;
		layout = new BALayout(this);
		setContentView(layout);
		afterFirstLayout = false;
        WaitForLayout wl = new WaitForLayout();
        if (anywheresoftware.b4a.objects.ServiceHelper.StarterHelper.startFromActivity(this, processBA, wl, false))
		    BA.handler.postDelayed(wl, 5);

	}
	static class WaitForLayout implements Runnable {
		public void run() {
			if (afterFirstLayout)
				return;
			if (mostCurrent == null)
				return;
            
			if (mostCurrent.layout.getWidth() == 0) {
				BA.handler.postDelayed(this, 5);
				return;
			}
			mostCurrent.layout.getLayoutParams().height = mostCurrent.layout.getHeight();
			mostCurrent.layout.getLayoutParams().width = mostCurrent.layout.getWidth();
			afterFirstLayout = true;
			mostCurrent.afterFirstLayout();
		}
	}
	private void afterFirstLayout() {
        if (this != mostCurrent)
			return;
		activityBA = new BA(this, layout, processBA, "b4a.example", "b4a.example.main");
        
        processBA.sharedProcessBA.activityBA = new java.lang.ref.WeakReference<BA>(activityBA);
        anywheresoftware.b4a.objects.ViewWrapper.lastId = 0;
        _activity = new ActivityWrapper(activityBA, "activity");
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (BA.isShellModeRuntimeCheck(processBA)) {
			if (isFirst)
				processBA.raiseEvent2(null, true, "SHELL", false);
			processBA.raiseEvent2(null, true, "CREATE", true, "b4a.example.main", processBA, activityBA, _activity, anywheresoftware.b4a.keywords.Common.Density, mostCurrent);
			_activity.reinitializeForShell(activityBA, "activity");
		}
        initializeProcessGlobals();		
        initializeGlobals();
        
        BA.LogInfo("** Activity (main) Create, isFirst = " + isFirst + " **");
        processBA.raiseEvent2(null, true, "activity_create", false, isFirst);
		isFirst = false;
		if (this != mostCurrent)
			return;
        processBA.setActivityPaused(false);
        BA.LogInfo("** Activity (main) Resume **");
        processBA.raiseEvent(null, "activity_resume");
        if (android.os.Build.VERSION.SDK_INT >= 11) {
			try {
				android.app.Activity.class.getMethod("invalidateOptionsMenu").invoke(this,(Object[]) null);
			} catch (Exception e) {
				e.printStackTrace();
			}
		}

	}
	public void addMenuItem(B4AMenuItem item) {
		if (menuItems == null)
			menuItems = new java.util.ArrayList<B4AMenuItem>();
		menuItems.add(item);
	}
	@Override
	public boolean onCreateOptionsMenu(android.view.Menu menu) {
		super.onCreateOptionsMenu(menu);
        try {
            if (processBA.subExists("activity_actionbarhomeclick")) {
                Class.forName("android.app.ActionBar").getMethod("setHomeButtonEnabled", boolean.class).invoke(
                    getClass().getMethod("getActionBar").invoke(this), true);
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        if (processBA.runHook("oncreateoptionsmenu", this, new Object[] {menu}))
            return true;
		if (menuItems == null)
			return false;
		for (B4AMenuItem bmi : menuItems) {
			android.view.MenuItem mi = menu.add(bmi.title);
			if (bmi.drawable != null)
				mi.setIcon(bmi.drawable);
            if (android.os.Build.VERSION.SDK_INT >= 11) {
				try {
                    if (bmi.addToBar) {
				        android.view.MenuItem.class.getMethod("setShowAsAction", int.class).invoke(mi, 1);
                    }
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
			mi.setOnMenuItemClickListener(new B4AMenuItemsClickListener(bmi.eventName.toLowerCase(BA.cul)));
		}
        
		return true;
	}   
 @Override
 public boolean onOptionsItemSelected(android.view.MenuItem item) {
    if (item.getItemId() == 16908332) {
        processBA.raiseEvent(null, "activity_actionbarhomeclick");
        return true;
    }
    else
        return super.onOptionsItemSelected(item); 
}
@Override
 public boolean onPrepareOptionsMenu(android.view.Menu menu) {
    super.onPrepareOptionsMenu(menu);
    processBA.runHook("onprepareoptionsmenu", this, new Object[] {menu});
    return true;
    
 }
 protected void onStart() {
    super.onStart();
    processBA.runHook("onstart", this, null);
}
 protected void onStop() {
    super.onStop();
    processBA.runHook("onstop", this, null);
}
    public void onWindowFocusChanged(boolean hasFocus) {
       super.onWindowFocusChanged(hasFocus);
       if (processBA.subExists("activity_windowfocuschanged"))
           processBA.raiseEvent2(null, true, "activity_windowfocuschanged", false, hasFocus);
    }
	private class B4AMenuItemsClickListener implements android.view.MenuItem.OnMenuItemClickListener {
		private final String eventName;
		public B4AMenuItemsClickListener(String eventName) {
			this.eventName = eventName;
		}
		public boolean onMenuItemClick(android.view.MenuItem item) {
			processBA.raiseEventFromUI(item.getTitle(), eventName + "_click");
			return true;
		}
	}
    public static Class<?> getObject() {
		return main.class;
	}
    private Boolean onKeySubExist = null;
    private Boolean onKeyUpSubExist = null;
	@Override
	public boolean onKeyDown(int keyCode, android.view.KeyEvent event) {
        if (processBA.runHook("onkeydown", this, new Object[] {keyCode, event}))
            return true;
		if (onKeySubExist == null)
			onKeySubExist = processBA.subExists("activity_keypress");
		if (onKeySubExist) {
			if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK &&
					android.os.Build.VERSION.SDK_INT >= 18) {
				HandleKeyDelayed hk = new HandleKeyDelayed();
				hk.kc = keyCode;
				BA.handler.post(hk);
				return true;
			}
			else {
				boolean res = new HandleKeyDelayed().runDirectly(keyCode);
				if (res)
					return true;
			}
		}
		return super.onKeyDown(keyCode, event);
	}
	private class HandleKeyDelayed implements Runnable {
		int kc;
		public void run() {
			runDirectly(kc);
		}
		public boolean runDirectly(int keyCode) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keypress", false, keyCode);
			if (res == null || res == true) {
                return true;
            }
            else if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK) {
				finish();
				return true;
			}
            return false;
		}
		
	}
    @Override
	public boolean onKeyUp(int keyCode, android.view.KeyEvent event) {
        if (processBA.runHook("onkeyup", this, new Object[] {keyCode, event}))
            return true;
		if (onKeyUpSubExist == null)
			onKeyUpSubExist = processBA.subExists("activity_keyup");
		if (onKeyUpSubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keyup", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyUp(keyCode, event);
	}
	@Override
	public void onNewIntent(android.content.Intent intent) {
        super.onNewIntent(intent);
		this.setIntent(intent);
        processBA.runHook("onnewintent", this, new Object[] {intent});
	}
    @Override 
	public void onPause() {
		super.onPause();
        if (_activity == null)
            return;
        if (this != mostCurrent)
			return;
		anywheresoftware.b4a.Msgbox.dismiss(true);
        if (!dontPause)
            BA.LogInfo("** Activity (main) Pause, UserClosed = " + activityBA.activity.isFinishing() + " **");
        else
            BA.LogInfo("** Activity (main) Pause event (activity is not paused). **");
        if (mostCurrent != null)
            processBA.raiseEvent2(_activity, true, "activity_pause", false, activityBA.activity.isFinishing());		
        if (!dontPause) {
            processBA.setActivityPaused(true);
            mostCurrent = null;
        }

        if (!activityBA.activity.isFinishing())
			previousOne = new WeakReference<Activity>(this);
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        processBA.runHook("onpause", this, null);
	}

	@Override
	public void onDestroy() {
        super.onDestroy();
		previousOne = null;
        processBA.runHook("ondestroy", this, null);
	}
    @Override 
	public void onResume() {
		super.onResume();
        mostCurrent = this;
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (activityBA != null) { //will be null during activity create (which waits for AfterLayout).
        	ResumeMessage rm = new ResumeMessage(mostCurrent);
        	BA.handler.post(rm);
        }
        processBA.runHook("onresume", this, null);
	}
    private static class ResumeMessage implements Runnable {
    	private final WeakReference<Activity> activity;
    	public ResumeMessage(Activity activity) {
    		this.activity = new WeakReference<Activity>(activity);
    	}
		public void run() {
            main mc = mostCurrent;
			if (mc == null || mc != activity.get())
				return;
			processBA.setActivityPaused(false);
            BA.LogInfo("** Activity (main) Resume **");
            if (mc != mostCurrent)
                return;
		    processBA.raiseEvent(mc._activity, "activity_resume", (Object[])null);
		}
    }
	@Override
	protected void onActivityResult(int requestCode, int resultCode,
	      android.content.Intent data) {
		processBA.onActivityResult(requestCode, resultCode, data);
        processBA.runHook("onactivityresult", this, new Object[] {requestCode, resultCode});
	}
	private static void initializeGlobals() {
		processBA.raiseEvent2(null, true, "globals", false, (Object[])null);
	}
    public void onRequestPermissionsResult(int requestCode,
        String permissions[], int[] grantResults) {
        for (int i = 0;i < permissions.length;i++) {
            Object[] o = new Object[] {permissions[i], grantResults[i] == 0};
            processBA.raiseEventFromDifferentThread(null,null, 0, "activity_permissionresult", true, o);
        }
            
    }

public anywheresoftware.b4a.keywords.Common __c = null;
public static anywheresoftware.b4a.objects.IntentWrapper _v0 = null;
public static byte[] _v5 = null;
public static int _v6 = 0;
public anywheresoftware.b4a.objects.NFC _v7 = null;
public anywheresoftware.b4a.objects.NFC.TagTechnologyWrapper _vv1 = null;
public anywheresoftware.b4a.objects.CompoundButtonWrapper.RadioButtonWrapper _rdbread = null;
public anywheresoftware.b4a.objects.CompoundButtonWrapper.RadioButtonWrapper _rdbwrite = null;
public anywheresoftware.b4a.objects.ListViewWrapper _listview1 = null;
public anywheresoftware.b4a.objects.FloatLabeledEditTextWrapper _fltxt1 = null;
public anywheresoftware.b4a.objects.FloatLabeledEditTextWrapper _fltxt2 = null;
public anywheresoftware.b4a.objects.EditTextWrapper _txtsector = null;
public anywheresoftware.b4a.objects.EditTextWrapper _txtblk = null;
public anywheresoftware.b4a.objects.CompoundButtonWrapper.RadioButtonWrapper _ka = null;
public anywheresoftware.b4a.objects.CompoundButtonWrapper.RadioButtonWrapper _kb = null;
public anywheresoftware.b4a.objects.CompoundButtonWrapper.RadioButtonWrapper _kff = null;
public anywheresoftware.b4a.objects.CompoundButtonWrapper.RadioButtonWrapper _ka0 = null;
public b4a.example.starter _vv4 = null;

public static boolean isAnyActivityVisible() {
    boolean vis = false;
vis = vis | (main.mostCurrent != null);
return vis;}
public static String  _activity_create(boolean _firsttime) throws Exception{
 //BA.debugLineNum = 52;BA.debugLine="Sub Activity_Create(FirstTime As Boolean)";
 //BA.debugLineNum = 54;BA.debugLine="Activity.LoadLayout(\"Layout1\")";
mostCurrent._activity.LoadLayout("Layout1",mostCurrent.activityBA);
 //BA.debugLineNum = 55;BA.debugLine="ListView1.SingleLineLayout.Label.TextSize = 14";
mostCurrent._listview1.getSingleLineLayout().Label.setTextSize((float) (14));
 //BA.debugLineNum = 56;BA.debugLine="ListView1.SetColorAnimated(Colors.Red,Colors.Blue";
mostCurrent._listview1.SetColorAnimated(anywheresoftware.b4a.keywords.Common.Colors.Red,anywheresoftware.b4a.keywords.Common.Colors.Blue,anywheresoftware.b4a.keywords.Common.Colors.Black);
 //BA.debugLineNum = 57;BA.debugLine="flTxt2.EditText.ForceDoneButton = True";
mostCurrent._fltxt2.getEditText().setForceDoneButton(anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 59;BA.debugLine="End Sub";
return "";
}
public static String  _activity_pause(boolean _userclosed) throws Exception{
 //BA.debugLineNum = 211;BA.debugLine="Sub Activity_Pause (UserClosed As Boolean)";
 //BA.debugLineNum = 212;BA.debugLine="nfc.DisableForegroundDispatch";
mostCurrent._v7.DisableForegroundDispatch(mostCurrent.activityBA);
 //BA.debugLineNum = 213;BA.debugLine="End Sub";
return "";
}
public static String  _activity_resume() throws Exception{
anywheresoftware.b4a.objects.IntentWrapper _si = null;
anywheresoftware.b4j.object.JavaObject _tag = null;
anywheresoftware.b4a.objects.collections.List _techs = null;
byte[] _id0 = null;
String[] _id = null;
anywheresoftware.b4j.object.JavaObject _jtagtech = null;
 //BA.debugLineNum = 61;BA.debugLine="Sub Activity_Resume 'ok";
 //BA.debugLineNum = 62;BA.debugLine="Try";
try { //BA.debugLineNum = 63;BA.debugLine="nfc.EnableForegroundDispatch";
mostCurrent._v7.EnableForegroundDispatch(mostCurrent.activityBA);
 //BA.debugLineNum = 64;BA.debugLine="Dim si As Intent = Activity.GetStartingIntent";
_si = new anywheresoftware.b4a.objects.IntentWrapper();
_si = mostCurrent._activity.GetStartingIntent();
 //BA.debugLineNum = 65;BA.debugLine="If si.IsInitialized = False Or si = prevIntent T";
if (_si.IsInitialized()==anywheresoftware.b4a.keywords.Common.False || (_si).equals(_v0)) { 
if (true) return "";};
 //BA.debugLineNum = 66;BA.debugLine="prevIntent = si";
_v0 = _si;
 //BA.debugLineNum = 67;BA.debugLine="Dim tag As JavaObject";
_tag = new anywheresoftware.b4j.object.JavaObject();
 //BA.debugLineNum = 68;BA.debugLine="If si.Action.EndsWith(\"TECH_DISCOVERED\") Or si.A";
if (_si.getAction().endsWith("TECH_DISCOVERED") || _si.getAction().endsWith("NDEF_DISCOVERED") || _si.getAction().endsWith("TAG_DISCOVERED")) { 
 //BA.debugLineNum = 69;BA.debugLine="Dim techs As List = nfc.GetTechList(si)";
_techs = new anywheresoftware.b4a.objects.collections.List();
_techs = anywheresoftware.b4a.keywords.Common.ArrayToList(mostCurrent._v7.GetTechList((android.content.Intent)(_si.getObject())));
 //BA.debugLineNum = 70;BA.debugLine="Log($\"Techs: ${techs}\"$)";
anywheresoftware.b4a.keywords.Common.LogImpl("2196617",("Techs: "+anywheresoftware.b4a.keywords.Common.SmartStringFormatter("",(Object)(_techs.getObject()))+""),0);
 //BA.debugLineNum = 72;BA.debugLine="Dim Id0() As  Byte";
_id0 = new byte[(int) (0)];
;
 //BA.debugLineNum = 73;BA.debugLine="Dim Id(8) As  String";
_id = new String[(int) (8)];
java.util.Arrays.fill(_id,"");
 //BA.debugLineNum = 74;BA.debugLine="Dim jTagTech As JavaObject";
_jtagtech = new anywheresoftware.b4j.object.JavaObject();
 //BA.debugLineNum = 76;BA.debugLine="If techs.IndexOf(\"android.nfc.tech.NfcA\")> -1 T";
if (_techs.IndexOf((Object)("android.nfc.tech.NfcA"))>-1) { 
 //BA.debugLineNum = 77;BA.debugLine="TagTech.Initialize(\"TagTech\", \"android.nfc.tec";
mostCurrent._vv1.Initialize("TagTech","android.nfc.tech.MifareClassic",(android.content.Intent)(_si.getObject()));
 //BA.debugLineNum = 78;BA.debugLine="TagTech.Connect";
mostCurrent._vv1.Connect(processBA);
 //BA.debugLineNum = 79;BA.debugLine="jTagTech  = TagTech";
_jtagtech = (anywheresoftware.b4j.object.JavaObject) anywheresoftware.b4a.AbsObjectWrapper.ConvertToWrapper(new anywheresoftware.b4j.object.JavaObject(), (java.lang.Object)(mostCurrent._vv1.getObject()));
 //BA.debugLineNum = 80;BA.debugLine="tag   = jTagTech.RunMethod(\"getTag\", Null)";
_tag = (anywheresoftware.b4j.object.JavaObject) anywheresoftware.b4a.AbsObjectWrapper.ConvertToWrapper(new anywheresoftware.b4j.object.JavaObject(), (java.lang.Object)(_jtagtech.RunMethod("getTag",(Object[])(anywheresoftware.b4a.keywords.Common.Null))));
 //BA.debugLineNum = 81;BA.debugLine="Id0   = tag.RunMethod(\"getId\", Null)";
_id0 = (byte[])(_tag.RunMethod("getId",(Object[])(anywheresoftware.b4a.keywords.Common.Null)));
 //BA.debugLineNum = 82;BA.debugLine="If Id0(0)>0 Or Id0(1)>0 Or Id0(2)>0 Or Id0(3)>";
if (_id0[(int) (0)]>0 || _id0[(int) (1)]>0 || _id0[(int) (2)]>0 || _id0[(int) (3)]>0) { 
 //BA.debugLineNum = 83;BA.debugLine="Id(0)=	Right(\"0\" & Bit.ToHexString(ToUnsigned";
_id[(int) (0)] = _vv2("0"+anywheresoftware.b4a.keywords.Common.Bit.ToHexString(_vv3(_id0[(int) (0)])),(int) (2));
 //BA.debugLineNum = 84;BA.debugLine="Id(1)=	Right(\"0\" & Bit.ToHexString(ToUnsigned";
_id[(int) (1)] = _vv2("0"+anywheresoftware.b4a.keywords.Common.Bit.ToHexString(_vv3(_id0[(int) (1)])),(int) (2));
 //BA.debugLineNum = 85;BA.debugLine="Id(2)=	Right(\"0\" & Bit.ToHexString(ToUnsigned";
_id[(int) (2)] = _vv2("0"+anywheresoftware.b4a.keywords.Common.Bit.ToHexString(_vv3(_id0[(int) (2)])),(int) (2));
 //BA.debugLineNum = 86;BA.debugLine="Id(3)=	Right(\"0\" & Bit.ToHexString(ToUnsigned";
_id[(int) (3)] = _vv2("0"+anywheresoftware.b4a.keywords.Common.Bit.ToHexString(_vv3(_id0[(int) (3)])),(int) (2));
 //BA.debugLineNum = 88;BA.debugLine="Log(Id(0)&\" \"&Id(1)&\" \"&Id(2)&\" \"&Id(3))";
anywheresoftware.b4a.keywords.Common.LogImpl("2196635",_id[(int) (0)]+" "+_id[(int) (1)]+" "+_id[(int) (2)]+" "+_id[(int) (3)],0);
 //BA.debugLineNum = 90;BA.debugLine="ListView1.AddSingleLine(Id(0)&\" \"&Id(1)&\" \"&I";
mostCurrent._listview1.AddSingleLine(BA.ObjectToCharSequence(_id[(int) (0)]+" "+_id[(int) (1)]+" "+_id[(int) (2)]+" "+_id[(int) (3)]));
 }else {
 //BA.debugLineNum = 92;BA.debugLine="ListView1.AddSingleLine(\"error in Id\")";
mostCurrent._listview1.AddSingleLine(BA.ObjectToCharSequence("error in Id"));
 };
 }else {
 //BA.debugLineNum = 95;BA.debugLine="ToastMessageShow(\"Tag does not support Ndef.\",";
anywheresoftware.b4a.keywords.Common.ToastMessageShow(BA.ObjectToCharSequence("Tag does not support Ndef."),anywheresoftware.b4a.keywords.Common.True);
 };
 };
 } 
       catch (Exception e34) {
			processBA.setLastException(e34); //BA.debugLineNum = 99;BA.debugLine="Log(LastException)";
anywheresoftware.b4a.keywords.Common.LogImpl("2196646",BA.ObjectToString(anywheresoftware.b4a.keywords.Common.LastException(mostCurrent.activityBA)),0);
 //BA.debugLineNum = 100;BA.debugLine="ListView1.AddSingleLine(\"error:\"&LastException)";
mostCurrent._listview1.AddSingleLine(BA.ObjectToCharSequence("error:"+BA.ObjectToString(anywheresoftware.b4a.keywords.Common.LastException(mostCurrent.activityBA))));
 };
 //BA.debugLineNum = 106;BA.debugLine="End Sub";
return "";
}
public static String  _authenticate_runasync(int _flag,boolean _success,Object _result) throws Exception{
int _blockindex = 0;
String _message = "";
 //BA.debugLineNum = 148;BA.debugLine="Private Sub Authenticate_RunAsync (Flag As Int, Su";
 //BA.debugLineNum = 149;BA.debugLine="Log($\"Finished trying to auth. Success=${Success}";
anywheresoftware.b4a.keywords.Common.LogImpl("2327681",("Finished trying to auth. Success="+anywheresoftware.b4a.keywords.Common.SmartStringFormatter("",(Object)(_success))+", Flag="+anywheresoftware.b4a.keywords.Common.SmartStringFormatter("",(Object)(_flag))+""),0);
 //BA.debugLineNum = 150;BA.debugLine="If Success Then";
if (_success) { 
 //BA.debugLineNum = 151;BA.debugLine="Dim blockIndex As Int=txtBLK.Text";
_blockindex = (int)(Double.parseDouble(mostCurrent._txtblk.getText()));
 //BA.debugLineNum = 153;BA.debugLine="Try";
try { //BA.debugLineNum = 154;BA.debugLine="Dim message  As String";
_message = "";
 //BA.debugLineNum = 155;BA.debugLine="message=\"pedramghaneipou\"";
_message = "pedramghaneipou";
 //BA.debugLineNum = 157;BA.debugLine="If rdbWrite.Checked Then";
if (mostCurrent._rdbwrite.getChecked()) { 
 //BA.debugLineNum = 158;BA.debugLine="TagTech.RunAsync(\"writeBlock\", \"writeBlock\", A";
mostCurrent._vv1.RunAsync(processBA,"writeBlock","writeBlock",new Object[]{(Object)(_blockindex),(Object)(_message)},(int) (0));
 }else {
 //BA.debugLineNum = 160;BA.debugLine="TagTech.RunAsync(\"readBlock\",\"readBlock\", Arra";
mostCurrent._vv1.RunAsync(processBA,"readBlock","readBlock",new Object[]{(Object)(_blockindex)},(int) (0));
 };
 } 
       catch (Exception e13) {
			processBA.setLastException(e13); //BA.debugLineNum = 163;BA.debugLine="ToastMessageShow(\"Read2:\"&LastException,False)";
anywheresoftware.b4a.keywords.Common.ToastMessageShow(BA.ObjectToCharSequence("Read2:"+BA.ObjectToString(anywheresoftware.b4a.keywords.Common.LastException(mostCurrent.activityBA))),anywheresoftware.b4a.keywords.Common.False);
 };
 }else {
 //BA.debugLineNum = 166;BA.debugLine="ListView1.AddSingleLine(\"Read error flag :\"& Fla";
mostCurrent._listview1.AddSingleLine(BA.ObjectToCharSequence("Read error flag :"+BA.NumberToString(_flag)));
 };
 //BA.debugLineNum = 168;BA.debugLine="End Sub";
return "";
}
public static String  _globals() throws Exception{
 //BA.debugLineNum = 35;BA.debugLine="Sub Globals";
 //BA.debugLineNum = 36;BA.debugLine="Private nfc As NFC";
mostCurrent._v7 = new anywheresoftware.b4a.objects.NFC();
 //BA.debugLineNum = 37;BA.debugLine="Private TagTech As TagTechnology";
mostCurrent._vv1 = new anywheresoftware.b4a.objects.NFC.TagTechnologyWrapper();
 //BA.debugLineNum = 39;BA.debugLine="Private rdbRead As RadioButton";
mostCurrent._rdbread = new anywheresoftware.b4a.objects.CompoundButtonWrapper.RadioButtonWrapper();
 //BA.debugLineNum = 40;BA.debugLine="Private rdbWrite As RadioButton";
mostCurrent._rdbwrite = new anywheresoftware.b4a.objects.CompoundButtonWrapper.RadioButtonWrapper();
 //BA.debugLineNum = 41;BA.debugLine="Private ListView1 As ListView";
mostCurrent._listview1 = new anywheresoftware.b4a.objects.ListViewWrapper();
 //BA.debugLineNum = 42;BA.debugLine="Private flTxt1 As FloatLabeledEditText";
mostCurrent._fltxt1 = new anywheresoftware.b4a.objects.FloatLabeledEditTextWrapper();
 //BA.debugLineNum = 43;BA.debugLine="Private flTxt2 As FloatLabeledEditText";
mostCurrent._fltxt2 = new anywheresoftware.b4a.objects.FloatLabeledEditTextWrapper();
 //BA.debugLineNum = 44;BA.debugLine="Private txtSector As EditText";
mostCurrent._txtsector = new anywheresoftware.b4a.objects.EditTextWrapper();
 //BA.debugLineNum = 45;BA.debugLine="Private txtBLK As EditText";
mostCurrent._txtblk = new anywheresoftware.b4a.objects.EditTextWrapper();
 //BA.debugLineNum = 46;BA.debugLine="Private ka As RadioButton";
mostCurrent._ka = new anywheresoftware.b4a.objects.CompoundButtonWrapper.RadioButtonWrapper();
 //BA.debugLineNum = 47;BA.debugLine="Private kb As RadioButton";
mostCurrent._kb = new anywheresoftware.b4a.objects.CompoundButtonWrapper.RadioButtonWrapper();
 //BA.debugLineNum = 48;BA.debugLine="Private kFF As RadioButton";
mostCurrent._kff = new anywheresoftware.b4a.objects.CompoundButtonWrapper.RadioButtonWrapper();
 //BA.debugLineNum = 49;BA.debugLine="Private kA0 As RadioButton";
mostCurrent._ka0 = new anywheresoftware.b4a.objects.CompoundButtonWrapper.RadioButtonWrapper();
 //BA.debugLineNum = 50;BA.debugLine="End Sub";
return "";
}
public static String  _listview1_itemlongclick(int _position,Object _value) throws Exception{
 //BA.debugLineNum = 230;BA.debugLine="Sub ListView1_ItemLongClick (Position As Int, Valu";
 //BA.debugLineNum = 231;BA.debugLine="ListView1.Clear";
mostCurrent._listview1.Clear();
 //BA.debugLineNum = 232;BA.debugLine="End Sub";
return "";
}

public static void initializeProcessGlobals() {
    
    if (main.processGlobalsRun == false) {
	    main.processGlobalsRun = true;
		try {
		        main._process_globals();
starter._process_globals();
		
        } catch (Exception e) {
			throw new RuntimeException(e);
		}
    }
}

private static byte[][] bb;

public static String vvv13(final byte[] _b, final int i) throws Exception {
Runnable r = new Runnable() {
{

int value = i / 6 + 772081;
if (bb == null) {
		
                bb = new byte[4][];
				bb[0] = BA.packageName.getBytes("UTF8");
                bb[1] = BA.applicationContext.getPackageManager().getPackageInfo(BA.packageName, 0).versionName.getBytes("UTF8");
                if (bb[1].length == 0)
                    bb[1] = "jsdkfh".getBytes("UTF8");
                bb[2] = new byte[] { (byte)BA.applicationContext.getPackageManager().getPackageInfo(BA.packageName, 0).versionCode };			
        }
        bb[3] = new byte[] {
                    (byte) (value >>> 24),
						(byte) (value >>> 16),
						(byte) (value >>> 8),
						(byte) value};
				try {
					for (int __b = 0;__b < (3 + 1);__b ++) {
						for (int b = 0;b<_b.length;b++) {
							_b[b] ^= bb[__b][b % bb[__b].length];
						}
					}

				} catch (Exception e) {
					throw new RuntimeException(e);
				}
                

            
}
public void run() {
}
};
return new String(_b, "UTF8");
}
public static String  _process_globals() throws Exception{
 //BA.debugLineNum = 26;BA.debugLine="Sub Process_Globals";
 //BA.debugLineNum = 27;BA.debugLine="Private prevIntent As Intent";
_v0 = new anywheresoftware.b4a.objects.IntentWrapper();
 //BA.debugLineNum = 29;BA.debugLine="Dim key() As Byte = Array As Byte(0xA0,0xA1,0xA2,";
_v5 = new byte[]{(byte) (0xa0),(byte) (0xa1),(byte) (0xa2),(byte) (0xa3),(byte) (0xa4),(byte) (0xa5)};
 //BA.debugLineNum = 31;BA.debugLine="Dim sector As Int=0";
_v6 = (int) (0);
 //BA.debugLineNum = 33;BA.debugLine="End Sub";
return "";
}
public static String  _readblock_runasync(int _flag,boolean _success,Object _result) throws Exception{
byte[] _myblock = null;
 //BA.debugLineNum = 180;BA.debugLine="Private Sub readBlock_RunAsync(Flag As Int, Succes";
 //BA.debugLineNum = 181;BA.debugLine="Log($\"Finished trying to read. Success=${Success}";
anywheresoftware.b4a.keywords.Common.LogImpl("2458753",("Finished trying to read. Success="+anywheresoftware.b4a.keywords.Common.SmartStringFormatter("",(Object)(_success))+", Flag="+anywheresoftware.b4a.keywords.Common.SmartStringFormatter("",(Object)(_flag))+""),0);
 //BA.debugLineNum = 182;BA.debugLine="Log(LastException)";
anywheresoftware.b4a.keywords.Common.LogImpl("2458754",BA.ObjectToString(anywheresoftware.b4a.keywords.Common.LastException(mostCurrent.activityBA)),0);
 //BA.debugLineNum = 183;BA.debugLine="If Success Then";
if (_success) { 
 //BA.debugLineNum = 184;BA.debugLine="If Result<>Null Then";
if (_result!= null) { 
 //BA.debugLineNum = 185;BA.debugLine="Dim myBlock() As Byte = Result";
_myblock = (byte[])(_result);
 //BA.debugLineNum = 186;BA.debugLine="ListView1.AddSingleLine(txtSector.Text & \">\"&tx";
mostCurrent._listview1.AddSingleLine(BA.ObjectToCharSequence(mostCurrent._txtsector.getText()+">"+mostCurrent._txtblk.getText()+":  "+_vv2("0"+anywheresoftware.b4a.keywords.Common.Bit.ToHexString(_vv3(_myblock[(int) (0)])),(int) (2))+" "+_vv2("0"+anywheresoftware.b4a.keywords.Common.Bit.ToHexString(_vv3(_myblock[(int) (1)])),(int) (2))+" "+_vv2("0"+anywheresoftware.b4a.keywords.Common.Bit.ToHexString(_vv3(_myblock[(int) (2)])),(int) (2))+" "+_vv2("0"+anywheresoftware.b4a.keywords.Common.Bit.ToHexString(_vv3(_myblock[(int) (3)])),(int) (2))+" "+_vv2("0"+anywheresoftware.b4a.keywords.Common.Bit.ToHexString(_vv3(_myblock[(int) (4)])),(int) (2))+" "+_vv2("0"+anywheresoftware.b4a.keywords.Common.Bit.ToHexString(_vv3(_myblock[(int) (5)])),(int) (2))+" "+_vv2("0"+anywheresoftware.b4a.keywords.Common.Bit.ToHexString(_vv3(_myblock[(int) (6)])),(int) (2))+" "+_vv2("0"+anywheresoftware.b4a.keywords.Common.Bit.ToHexString(_vv3(_myblock[(int) (7)])),(int) (2))+" "+_vv2("0"+anywheresoftware.b4a.keywords.Common.Bit.ToHexString(_vv3(_myblock[(int) (8)])),(int) (2))+" "+_vv2("0"+anywheresoftware.b4a.keywords.Common.Bit.ToHexString(_vv3(_myblock[(int) (9)])),(int) (2))+" "+_vv2("0"+anywheresoftware.b4a.keywords.Common.Bit.ToHexString(_vv3(_myblock[(int) (10)])),(int) (2))+" "+_vv2("0"+anywheresoftware.b4a.keywords.Common.Bit.ToHexString(_vv3(_myblock[(int) (11)])),(int) (2))+" "+_vv2("0"+anywheresoftware.b4a.keywords.Common.Bit.ToHexString(_vv3(_myblock[(int) (12)])),(int) (2))+" "+_vv2("0"+anywheresoftware.b4a.keywords.Common.Bit.ToHexString(_vv3(_myblock[(int) (13)])),(int) (2))+" "+_vv2("0"+anywheresoftware.b4a.keywords.Common.Bit.ToHexString(_vv3(_myblock[(int) (14)])),(int) (2))+" "+_vv2("0"+anywheresoftware.b4a.keywords.Common.Bit.ToHexString(_vv3(_myblock[(int) (15)])),(int) (2))+" "));
 //BA.debugLineNum = 204;BA.debugLine="TagTech.Close";
mostCurrent._vv1.Close();
 };
 }else {
 //BA.debugLineNum = 207;BA.debugLine="ListView1.AddSingleLine(\"cannot read\")";
mostCurrent._listview1.AddSingleLine(BA.ObjectToCharSequence("cannot read"));
 };
 //BA.debugLineNum = 209;BA.debugLine="End Sub";
return "";
}
public static String  _vv2(String _text,int _length) throws Exception{
 //BA.debugLineNum = 221;BA.debugLine="Sub Right(Text As String, Length As Int) As String";
 //BA.debugLineNum = 222;BA.debugLine="If Length>Text.Length Then Length=Text.Length";
if (_length>_text.length()) { 
_length = _text.length();};
 //BA.debugLineNum = 223;BA.debugLine="Return Text.SubString(Text.Length-Length)";
if (true) return _text.substring((int) (_text.length()-_length));
 //BA.debugLineNum = 224;BA.debugLine="End Sub";
return "";
}
public static String  _tagtech_connected(boolean _success) throws Exception{
 //BA.debugLineNum = 108;BA.debugLine="Private Sub TagTech_Connected (Success As Boolean)";
 //BA.debugLineNum = 109;BA.debugLine="Log($\"Connected: ${Success}\"$)";
anywheresoftware.b4a.keywords.Common.LogImpl("2262145",("Connected: "+anywheresoftware.b4a.keywords.Common.SmartStringFormatter("",(Object)(_success))+""),0);
 //BA.debugLineNum = 110;BA.debugLine="sector=txtSector.Text";
_v6 = (int)(Double.parseDouble(mostCurrent._txtsector.getText()));
 //BA.debugLineNum = 112;BA.debugLine="If kA0.Checked Then";
if (mostCurrent._ka0.getChecked()) { 
 //BA.debugLineNum = 113;BA.debugLine="key(0)=0xA0";
_v5[(int) (0)] = (byte) (0xa0);
 //BA.debugLineNum = 114;BA.debugLine="key(1)=0xA1";
_v5[(int) (1)] = (byte) (0xa1);
 //BA.debugLineNum = 115;BA.debugLine="key(2)=0xA2";
_v5[(int) (2)] = (byte) (0xa2);
 //BA.debugLineNum = 116;BA.debugLine="key(3)=0xA3";
_v5[(int) (3)] = (byte) (0xa3);
 //BA.debugLineNum = 117;BA.debugLine="key(4)=0xA4";
_v5[(int) (4)] = (byte) (0xa4);
 //BA.debugLineNum = 118;BA.debugLine="key(5)=0xA5";
_v5[(int) (5)] = (byte) (0xa5);
 }else if(mostCurrent._kff.getChecked()) { 
 //BA.debugLineNum = 121;BA.debugLine="key(0)=0xFF";
_v5[(int) (0)] = (byte) (0xff);
 //BA.debugLineNum = 122;BA.debugLine="key(1)=0xFF";
_v5[(int) (1)] = (byte) (0xff);
 //BA.debugLineNum = 123;BA.debugLine="key(2)=0xFF";
_v5[(int) (2)] = (byte) (0xff);
 //BA.debugLineNum = 124;BA.debugLine="key(3)=0xFF";
_v5[(int) (3)] = (byte) (0xff);
 //BA.debugLineNum = 125;BA.debugLine="key(4)=0xFF";
_v5[(int) (4)] = (byte) (0xff);
 //BA.debugLineNum = 126;BA.debugLine="key(5)=0xFF";
_v5[(int) (5)] = (byte) (0xff);
 };
 //BA.debugLineNum = 130;BA.debugLine="If Success = False Then";
if (_success==anywheresoftware.b4a.keywords.Common.False) { 
 //BA.debugLineNum = 131;BA.debugLine="ToastMessageShow(\"Error connecting to tag\", True";
anywheresoftware.b4a.keywords.Common.ToastMessageShow(BA.ObjectToCharSequence("Error connecting to tag"),anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 132;BA.debugLine="Log(LastException)";
anywheresoftware.b4a.keywords.Common.LogImpl("2262168",BA.ObjectToString(anywheresoftware.b4a.keywords.Common.LastException(mostCurrent.activityBA)),0);
 }else {
 //BA.debugLineNum = 134;BA.debugLine="Try";
try { //BA.debugLineNum = 135;BA.debugLine="If ka.Checked Then";
if (mostCurrent._ka.getChecked()) { 
 //BA.debugLineNum = 136;BA.debugLine="TagTech.RunAsync(\"Authenticate\", \"authenticate";
mostCurrent._vv1.RunAsync(processBA,"Authenticate","authenticateSectorWithKeyA",new Object[]{(Object)(_v6),(Object)(_v5)},(int) (0));
 }else {
 //BA.debugLineNum = 138;BA.debugLine="TagTech.RunAsync(\"Authenticate\", \"authenticate";
mostCurrent._vv1.RunAsync(processBA,"Authenticate","authenticateSectorWithKeyB",new Object[]{(Object)(_v6),(Object)(_v5)},(int) (0));
 };
 } 
       catch (Exception e29) {
			processBA.setLastException(e29); //BA.debugLineNum = 142;BA.debugLine="ToastMessageShow(\"Ath1:\"&LastException,False)";
anywheresoftware.b4a.keywords.Common.ToastMessageShow(BA.ObjectToCharSequence("Ath1:"+BA.ObjectToString(anywheresoftware.b4a.keywords.Common.LastException(mostCurrent.activityBA))),anywheresoftware.b4a.keywords.Common.False);
 };
 };
 //BA.debugLineNum = 146;BA.debugLine="End Sub";
return "";
}
public static int  _vv3(byte _b) throws Exception{
String _x = "";
 //BA.debugLineNum = 215;BA.debugLine="Sub ToUnsigned(b As Byte) As Int";
 //BA.debugLineNum = 216;BA.debugLine="Dim x As String";
_x = "";
 //BA.debugLineNum = 217;BA.debugLine="x= Bit.And(0xFF, b)";
_x = BA.NumberToString(anywheresoftware.b4a.keywords.Common.Bit.And((int) (0xff),(int) (_b)));
 //BA.debugLineNum = 218;BA.debugLine="Return x";
if (true) return (int)(Double.parseDouble(_x));
 //BA.debugLineNum = 219;BA.debugLine="End Sub";
return 0;
}
public static String  _writeblock_runasync(int _flag,boolean _success,Object _result) throws Exception{
 //BA.debugLineNum = 170;BA.debugLine="Private Sub writeBlock_RunAsync (Flag As Int, Succ";
 //BA.debugLineNum = 171;BA.debugLine="Log($\"Writing completed. Success=${Success}, Flag";
anywheresoftware.b4a.keywords.Common.LogImpl("2393217",("Writing completed. Success="+anywheresoftware.b4a.keywords.Common.SmartStringFormatter("",(Object)(_success))+", Flag="+anywheresoftware.b4a.keywords.Common.SmartStringFormatter("",(Object)(_flag))+""),0);
 //BA.debugLineNum = 172;BA.debugLine="If Success Then";
if (_success) { 
 //BA.debugLineNum = 173;BA.debugLine="ListView1.AddSingleLine(\"Write ok:\"&Result)";
mostCurrent._listview1.AddSingleLine(BA.ObjectToCharSequence("Write ok:"+BA.ObjectToString(_result)));
 }else {
 //BA.debugLineNum = 175;BA.debugLine="ListView1.AddSingleLine(\"Write error:\"&Result)";
mostCurrent._listview1.AddSingleLine(BA.ObjectToCharSequence("Write error:"+BA.ObjectToString(_result)));
 };
 //BA.debugLineNum = 178;BA.debugLine="End Sub";
return "";
}
}
